package org.nakedobjects.nof.reflect.java.annotations;

import java.lang.reflect.Method;
import java.util.Collection;

import org.nakedobjects.noa.annotations.Annotation;


public interface AnnotationFactorySet {

    public AnnotationFactory getFactory(Class annotationType);

    public Collection getFactories();

    /**
     * Returns all annotations applicable to the provided class.
     * 
     * @param clazz
     * @return
     */
    public Annotation[] process(Class clazz);

    /**
     * Returns all annotations applicable to the provided method.
     * 
     * @param clazz
     * @return
     */
    public Annotation[] process(Method method);

    /**
     * Returns all annotations applicable to the specified parameter of the method.
     * 
     * @param method -
     *            action method to process
     * @param paramNum -
     *            0-based
     * @return
     */
    public Annotation[] processParams(Method method, int paramNum);
}
