package org.nakedobjects.nof.reflect.java.annotations;

import java.lang.reflect.Method;

import org.nakedobjects.applib.annotation.Hidden;
import org.nakedobjects.noa.annotations.Annotation;
import org.nakedobjects.noa.annotations.HiddenAnnotation;


public class HiddenAnnotationFactory extends AbstractAnnotationFactory {

    public HiddenAnnotationFactory() {
        super(HiddenAnnotation.class);
    }

    public Annotation process(final Class clazz) {
        Hidden annotation = (Hidden) clazz.getAnnotation(Hidden.class);
        return create(annotation);
    }

    public Annotation process(final Method method) {
        return create((Hidden) method.getAnnotation(Hidden.class));
    }

    private HiddenAnnotation create(final Hidden annotation) {
        return annotation == null ? null : new HiddenAnnotation(decodeWhen(annotation.value()));
    }

}
