package org.nakedobjects.nof.reflect.java.annotations;

import java.lang.reflect.Method;

import org.nakedobjects.applib.annotation.Immutable;
import org.nakedobjects.noa.annotations.Annotation;
import org.nakedobjects.noa.annotations.ImmutableAnnotation;


public class ImmutableAnnotationFactory extends AbstractAnnotationFactory {

    public ImmutableAnnotationFactory() {
        super(ImmutableAnnotation.class);
    }

    public Annotation process(final Class clazz) {
        Immutable annotation = (Immutable) clazz.getAnnotation(Immutable.class);
        return create(annotation);
    }

    public Annotation process(final Method method) {
        return create((Immutable) method.getAnnotation(Immutable.class));
    }

    private ImmutableAnnotation create(Immutable annotation) {
        return annotation == null ? null : new ImmutableAnnotation(decodeWhen(annotation.value()));
    }

}
