package org.nakedobjects.nof.reflect.java.annotations;

import java.lang.reflect.Method;

import org.nakedobjects.applib.annotation.MemberOrder;
import org.nakedobjects.noa.annotations.Annotation;
import org.nakedobjects.noa.annotations.MemberOrderAnnotation;


public class MemberOrderAnnotationFactory extends AbstractAnnotationFactory {

    public MemberOrderAnnotationFactory() {
        super(MemberOrderAnnotation.class);
    }

    public Annotation process(final Method method) {
        MemberOrder annotation = (MemberOrder) method.getAnnotation(MemberOrder.class);
        return create(annotation);
    }

    private MemberOrderAnnotation create(MemberOrder annotation) {
        return annotation == null ? null : new MemberOrderAnnotation(annotation.name(), annotation.sequence());
    }

}
