package org.nakedobjects.nof.reflect.java.annotations;

import java.lang.reflect.Method;

import org.nakedobjects.applib.annotation.Named;
import org.nakedobjects.noa.annotations.Annotation;
import org.nakedobjects.noa.annotations.NamedAnnotation;


public class NamedAnnotationFactory extends AbstractAnnotationFactory {

    public NamedAnnotationFactory() {
        super(NamedAnnotation.class);
    }

    public Annotation process(Class clazz) {
        Named annotation = (Named) clazz.getAnnotation(Named.class);
        return create(annotation);
    }

    public Annotation process(final Method method) {
        Named annotation = (Named) method.getAnnotation(Named.class);
        return create(annotation);
    }

    public Annotation processParams(Method method, int paramNum) {

        java.lang.annotation.Annotation[] parameterAnnotations = method.getParameterAnnotations()[paramNum];

        for (int j = 0; j < parameterAnnotations.length; j++) {
            if (parameterAnnotations[j] instanceof Named) {
                return create((Named) parameterAnnotations[j]);
            }
        }
        return null;
    }

    private NamedAnnotation create(Named annotation) {
        return annotation == null ? null : new NamedAnnotation(annotation.value());
    }

}
