package org.nakedobjects.nof.reflect.java.annotations;

import java.lang.reflect.Method;

import org.nakedobjects.applib.annotation.NotPersistable;
import org.nakedobjects.noa.annotations.Annotation;
import org.nakedobjects.noa.annotations.NotPersistableAnnotation;
import org.nakedobjects.noa.annotations.NotPersistableAnnotation.By;


public class NotPersistableAnnotationFactory extends AbstractAnnotationFactory {

    public NotPersistableAnnotationFactory() {
        super(NotPersistableAnnotation.class);
    }

    public Annotation process(final Class clazz) {
        NotPersistable annotation = (NotPersistable) clazz.getAnnotation(NotPersistable.class);
        return create(annotation);
    }

    public Annotation process(final Method method) {
        NotPersistable annotation = (NotPersistable) method.getAnnotation(NotPersistable.class);
        return create(annotation);
    }

    private NotPersistableAnnotation create(NotPersistable annotation) {
        return annotation == null ? null : new NotPersistableAnnotation(decodeBy(annotation.value()));
    }

    protected By decodeBy(NotPersistable.By by) {
          if (by == NotPersistable.By.USER) {
            return org.nakedobjects.noa.annotations.NotPersistableAnnotation.By.USER;
        }
        if (by == NotPersistable.By.USER_OR_PROGRAM) {
            return org.nakedobjects.noa.annotations.NotPersistableAnnotation.By.USER_OR_PROGRAM;
        }
        return null;
    }

}
