package org.nakedobjects.nof.reflect.java.annotations;

import java.lang.reflect.Method;

import org.nakedobjects.applib.annotation.Optional;
import org.nakedobjects.noa.annotations.Annotation;
import org.nakedobjects.noa.annotations.OptionalAnnotation;


public class OptionalAnnotationFactory extends AbstractAnnotationFactory {

    public OptionalAnnotationFactory() {
        super(OptionalAnnotation.class);
    }

    public Annotation process(final Method method) {
        if (!method.isAnnotationPresent(Optional.class)) {
            return null;
        }
        Optional annotation = (Optional) method.getAnnotation(Optional.class);
        return create(annotation);
    }

    public Annotation processParams(Method method, int paramNum) {

        java.lang.annotation.Annotation[] parameterAnnotations = method.getParameterAnnotations()[paramNum];

        for (int j = 0; j < parameterAnnotations.length; j++) {
            if (parameterAnnotations[j] instanceof Optional) {
                return new OptionalAnnotation();
            }
        }

        return null;
    }

    private OptionalAnnotation create(Optional annotation) {
        return annotation == null ? null : new OptionalAnnotation();
    }

}
