package org.nakedobjects.nof.reflect.java.annotations;

import org.nakedobjects.applib.annotation.Plural;
import org.nakedobjects.noa.annotations.Annotation;
import org.nakedobjects.noa.annotations.PluralAnnotation;


public class PluralAnnotationFactory extends AbstractAnnotationFactory {

    public PluralAnnotationFactory() {
        super(PluralAnnotation.class);
    }

    public Annotation process(final Class cls) {
        Plural annotation = (Plural) cls.getAnnotation(Plural.class);
        return create(annotation);
    }

    private PluralAnnotation create(Plural annotation) {
        return annotation == null ? null : new PluralAnnotation(annotation.value());
    }

}
