package org.nakedobjects.nof.reflect.java.annotations;

import org.nakedobjects.applib.annotation.Value;
import org.nakedobjects.noa.annotations.Annotation;
import org.nakedobjects.noa.annotations.ValueAnnotation;


public class ValueAnnotationFactory extends AbstractAnnotationFactory {

    public ValueAnnotationFactory() {
        super(ValueAnnotation.class);
    }

    public Annotation process(Class clazz) {
        Value annotation = (Value) clazz.getAnnotation(Value.class);
        return create(annotation);
    }

    private ValueAnnotation create(Value annotation) {
        if (annotation == null) {
            return null;
        }
        return new ValueAnnotation(annotation.adapterTypeName());
    }

}
