package org.nakedobjects.nof.reflect.java.reflect;

import java.util.HashMap;
import java.util.Map;

import org.nakedobjects.noa.spec.NamedAndDescribedExtensionHolder;

/**
 * For base subclasses or, more likely, to help write tests.
 */
public class DefaultExtensionHolderMutable implements NamedAndDescribedExtensionHolder {



    public DefaultExtensionHolderMutable(String name) {
        this(name, null);
    }
    public DefaultExtensionHolderMutable(String name, String description) {
        this.name = name;
        this.description = description;
    }

    private String name;
    public String getName() {
        return name;
    }
    
    private String description;
    public String getDescription() {
        return description;
    }
    
    private Map extensionsByClass = new HashMap();
    
    public void addExtension(
            Object extension) {
        extensionsByClass.put(extension.getClass(), extension);
    }

    public Object getExtension(
            Class cls) {
        return extensionsByClass.get(cls);
    }

    public Class[] getExtensions() {
        return (Class[]) extensionsByClass.values().toArray(new Class[]{});
    }



}
