package org.nakedobjects.nof.reflect.java.reflect;

import java.lang.reflect.Method;


public class FieldMethods {

    private final Method associateMethod;
    private final Method defaultMethod;
    private final Method dissociateMethod;
    private final Method getMethod;
    private final Method optionsMethod;
    private final Method setMethod;

    public FieldMethods(Method getMethod, Method setMethod) {
        this(getMethod, setMethod, null, null, null, null);
    }

    public FieldMethods(Method getMethod, Method setMethod, Method associateMethod, Method dissociateMethod, Method defaultMethod, Method optionsMethod) {
        this.getMethod = getMethod;
        this.setMethod = setMethod;
        this.associateMethod = associateMethod;
        this.dissociateMethod = dissociateMethod;
        this.defaultMethod = defaultMethod;
        this.optionsMethod = optionsMethod;
    }

    public final Method getAssociateMethod() {
        return associateMethod;
    }

    public final Method getDefaultMethod() {
        return defaultMethod;
    }

    public final Method getDissociateMethod() {
        return dissociateMethod;
    }

    public final Method getGetMethod() {
        return getMethod;
    }

    public final Method getOptionsMethod() {
        return optionsMethod;
    }

    public final Method getSetMethod() {
        return setMethod;
    }
}

// Copyright (c) Naked Objects Group Ltd.
