package org.nakedobjects.nof.reflect.java.reflect;

import java.util.Comparator;

import org.nakedobjects.noa.annotations.MemberOrderAnnotation;
import org.nakedobjects.noa.spec.ExtensionHolder;
import org.nakedobjects.nof.reflect.peer.MemberPeer;

/**
 * Compares {@link MemberPeer}) by {@link MemberPeer#getIdentifier()}
 * 
 */
public class MemberIdentifierComparator implements Comparator {

    public int compare(
            Object o1,
            Object o2) {
        if (o1 instanceof MemberPeer && o2 instanceof MemberPeer) {
            return compare((MemberPeer)o1, (MemberPeer)o2);
        }
        throw new IllegalArgumentException("can only compare MemberPeers");
    }

    public int compare(
            MemberPeer o1,
            MemberPeer o2) {
        MemberOrderAnnotation m1 = getMemberOrder(o1);
        MemberOrderAnnotation m2 = getMemberOrder(o2);

        return o1.getIdentifier().compareTo(o2.getIdentifier());
    }

    private MemberOrderAnnotation getMemberOrder(
            ExtensionHolder eh) {
        return (MemberOrderAnnotation) eh.getExtension(MemberOrderAnnotation.class);
    }

}
