package org.nakedobjects.nof.reflect.java.reflect;

import java.util.Comparator;

import org.nakedobjects.noa.spec.NamedAndDescribed;

/**
 * Compares {@link NamedAndDescribed}s by name.
 */
public class NamedAndDescribedNameComparator implements Comparator {

    public int compare(
            Object o1,
            Object o2) {
        return compare((NamedAndDescribed)o1, (NamedAndDescribed)o2);
    }

    public int compare(
            NamedAndDescribed o1,
            NamedAndDescribed o2) {
        
        String name1 = o1.getName();
        String name2 = o2.getName();
        
        if (name1 == null && name2 == null) return 0;
        if (name1 == null && name2 != null) return -1;
        if (name1 != null && name2 == null) return +1;
        
        return name1.compareTo(name2);
    }

}
