package org.nakedobjects.nof.reflect.java.reflect;

import java.util.Vector;

import org.nakedobjects.nof.reflect.java.annotations.AnnotationFactorySet;
import org.nakedobjects.nof.reflect.java.annotations.JavaIntrospectorAnnotationExtension;

/**
 * Strategy for introspecting one to many associations.
 */
interface OneToManyStrategy {
	
	/**
	 * Get the return type of methods which fit this strategy
	 */
	Class getReturnType();
	
	/**
	 * Introspect all associations, placing generated peers in the <i>associations</i> Vector
	 * @param extension 
	 */
	void introspectAssociations(
            final JavaIntrospector introspector, 
            final JavaIntrospectorAnnotationExtension extension,
            final AnnotationFactorySet annotationFactorySet,
            final Vector associations);
}
// Copyright (c) Naked Objects Group Ltd.