package org.nakedobjects.nof.reflect.java.reflect;

public class ParameterMethods {
    private final MemberHelper namesMethod;
    private final MemberHelper optionalMethod;
    private final MemberHelper optionsMethod;
    private final MemberHelper defaultsMethod;
    private final MemberHelper descriptionsMethod;
    private final int[] maxLengths;
    private final int[] typicalLengths;
    private final int[] noLines;
    private final boolean[] canWrap;

    public ParameterMethods(
            final MemberHelper namesMethod,
            final MemberHelper descriptionsMethod,
            final MemberHelper optionalMethod,
            final MemberHelper defaultsMethod,
            final MemberHelper optionsMethod,
            final int[] maxLengths,
            final int[] typicalLengths,
            final int[] noLines,
            final boolean[] canWrap) {
        this.namesMethod = namesMethod;
        this.descriptionsMethod = descriptionsMethod;
        this.optionalMethod = optionalMethod;
        this.defaultsMethod = defaultsMethod;
        this.optionsMethod = optionsMethod;
        this.maxLengths = maxLengths;
        this.typicalLengths = typicalLengths;
        this.noLines = noLines;
        this.canWrap = canWrap;
    }

    public boolean[] canWrap() {
        return canWrap;
    }

    public final MemberHelper getDefaultsMethod() {
        return defaultsMethod;
    }

    public final MemberHelper getDescriptionsMethod() {
        return descriptionsMethod;
    }

    public final MemberHelper getOptionalMethod() {
        return optionalMethod;
    }

    public int[] getMaxLengths() {
        return maxLengths;
    }

    public final MemberHelper getNamesMethod() {
        return namesMethod;
    }

    public int[] getNoLines() {
        return noLines;
    }

    public final MemberHelper getOptionsMethod() {
        return optionsMethod;
    }

    public int[] getTypicalLengths() {
        return typicalLengths;
    }
}

// Copyright (c) Naked Objects Group Ltd.
