package org.nakedobjects.nof.reflect.java.value;

import org.nakedobjects.applib.value.DateTime;
import org.nakedobjects.nof.core.adapter.value.AbstractDateTimeAdapter;

import java.util.Date;


public class DateTimeAdapter extends AbstractDateTimeAdapter {
    private DateTime date;

    public DateTimeAdapter() {
    }

    public DateTimeAdapter(final DateTime date) {
        this.date = date;
    }

    public boolean isEmpty() {
        return date == null;
    }

    public java.util.Date dateValue() {
        return date == null ? null : date.dateValue();
    }

    public Object getObject() {
        return date;
    }

    public Class getValueClass() {
        return DateTime.class;
    }

    public void setValue(java.util.Date date) {
        this.date = new DateTime(date);
    }
    
    public String toString() {
        return "DateTimeAdapter: " + date;
    }

    protected void add(int years, int months, int days, int hours, int minutes) {
        date = date.add(years, months, days, hours, minutes);
    }

    protected void now() {
        date = new DateTime();
    }

    protected void setDate(Date date) {
        this.date = new DateTime(date);
    }

    public void clear() {
        date = null;
    }

}

// Copyright (c) Naked Objects Group Ltd.
