package org.nakedobjects.nof.reflect.java.value;

import org.nakedobjects.applib.value.Image;
import org.nakedobjects.nof.core.adapter.value.AbstractImageAdapter;


public class ImageAdapter extends AbstractImageAdapter {
    private Image image;

    public ImageAdapter() {
        image = null;
    }

    public ImageAdapter(final Image image) {
        this.image = image;
    }

    public void clear() {
        image = null;
    }

    public int getHeight() {
        return image.getHeight();
    }

    public java.awt.Image getImage() {
        return isEmpty() ? null : createImage(image.getImage());
    }

    public Object getObject() {
        return image;
    }

    protected int[][] getPixels() {
        return image.getImage();
    }

    public Class getValueClass() {
        return Image.class;
    }

    public int getWidth() {
        return image.getWidth();
    }

    public boolean isEmpty() {
        return image == null;
    }

    public void setImage(java.awt.Image image) {
        this.image = new Image(grabPixels(image));
    }

    protected void setPixels(int[][] pixels) {
        this.image = new Image(pixels);
    }

    public String toString() {
        return "ImageAdapter: " + image;
    }

}
// Copyright (c) Naked Objects Group Ltd.
