package org.nakedobjects.nof.reflect.java.value;

import org.nakedobjects.applib.value.Time;
import org.nakedobjects.noa.adapter.value.TimeValue;
import org.nakedobjects.nof.core.adapter.value.AbstractTimeAdapter;

import java.util.Date;
import java.util.Hashtable;


public class TimeAdapter extends AbstractTimeAdapter implements TimeValue {
    private static Hashtable formats = new Hashtable();
    
    static {
        initFormats(formats);
    }

    private Time time;
    
    protected Hashtable formats() {
        return formats;
    }

    protected boolean ignoreTimeZone() {
        return true;
    }

    public TimeAdapter() {
    }

    public TimeAdapter(final Time time) {
        this.time = time;
    }

    public void clear() {
        time = null;
    }

    public Object getObject() {
        return time;
    }

    public Class getValueClass() {
        return org.nakedobjects.applib.value.Time.class;
    }

    public boolean isEmpty() {
        return time == null;
    }

    public void setValue(final Date date) {
        this.time = new Time(date);
    }

    public Date timeValue() {
        return time.dateValue();
    }

    public String toString() {
        return "TimeAdapter: " + time;
    }

    protected void add(int years, int months, int days, int hours, int minutes) {
        time = time.add(hours, minutes);
    }

    protected Date dateValue() {
        return time == null ? null : time.dateValue();
    }

    protected void now() {
        time = new Time();
    }

    protected void setDate(Date date) {
        time = new Time(date);
    }
    
    
}
// Copyright (c) Naked Objects Group Ltd.
